<?php
/***************************************************************************
 *                             config.php
 *                            -------------------
 *   copyright            : redgun
 *   email                : _redgun@libero.it
 *
 *   config.php   start 13 August 2004
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
 
define('REDBLOG', true);
$root_path='./../';
require_once($root_path . 'common.php');
require_once($root_path . 'includes/functions.php');

// Only admin can access to this area
if (!admin_logged_in()) {
	header("Location:  http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php");
	exit;
}

$error = false;
$stored = false;
if ( count($_POST) != 0 ) {
	$var = array();
	while ( list($key, $value) = each($config) ) {
		if  ($key != 'admin_password') {
			if ( ( ! array_key_exists( $key, $_POST ) ) || ($_POST[$key] == "") ){
				$error = true;
			}
			else { $var[$key] = $_POST[$key]; }
		}
	}
	if (!$error) {
		foreach ( $var as $key => $value ) {
			$sql = 'UPDATE ' . CONFIG_TABLE . ' SET  config_value="' .$value. '" WHERE config_name="' .$key. '"';
			if( !($result = $db->sql_query($sql)) ) {
				die("Can't update configuration!".$sql);
			}
		}
		$template->set_filenames(array(
			'body' => 'admin/notice_body.html')
		);
		$link = '<a href="posting.php"> '.$lang['back_to_admin_panel'].' </a>';
		$template->assign_vars(array(		
			'NOTICE' => $lang['insert_success'],
			'LINK' => $link)
		);
		$stored = true;
	}
}
if ( $error ) {
	$template->set_filenames(array(
		'body' => 'admin/notice_body.html')
	);
	$link = '<a href="config.php"> '.$lang['go_back'].'</a>';
	$template->assign_vars(array(
		'NOTICE' => $lang['fill'],
		'LINK' => $link)
	);
}
else if ( !$stored ) {
	// In $config[] I have global configuration by common.php
	$time = time();
	$text_month = parse_months( date ('n', $time) );
	$day = date('j', $time);
	$year = date('Y', $time); 
	$current_time = $day." ".$text_month." ".$year." -- ".date('H:i', $time);
	
	$template->set_filenames(array(
		'body' => 'admin/admin_config.html')
	);
	
	$template->assign_vars(array(			
		'ACTION' => "config.php",
		'LANG_SUBMIT' => $lang['submit'],
		
		'LANG_POSTS_PER_PAGE' => $lang['posts_per_page'],
		'POSTS_PER_PAGE_VALUE' => $config['posts_per_page'],
		'LANG_COMMENTS_PER_PAGE' => $lang['comments_per_page'],
		'COMMENTS_PER_PAGE_VALUE' => $config['comments_per_page'],
		'TIME_DIFFERENCE' => $config['time_difference'],
		'LANG_THUMBNAIL_SIZE' => $lang['thumbnail_size'],
		'THUMBNAIL_SIZE_VALUE' => $config['thumbnail_size'],
		'LANG_THUMBNAIL_QUALITY' => $lang['thumbnail_quality'],
		'THUMBNAIL_QUALITY_VALUE' => $config['thumbnail_quality'],
		'LANG_SITE_NAME' => $lang['site_name'],
		'SITE_NAME_VALUE' => $config['site_name'],
		'LANG_FTP_SERVER' => $lang['ftp_server'],
		'FTP_SERVER_VALUE' => $config['ftp_server'],
		'LANG_FTP_USER' => $lang['ftp_user'],
		'FTP_USER_VALUE' => $config['ftp_user'],
		'LANG_FTP_PASSWORD' => $lang['ftp_password'],
		'FTP_PASSWORD_VALUE' => $config['ftp_password'],
		'LANG_REDBLOG_HOME_PATH' => $lang['redblog_home_path'],
		'REDBLOG_HOME_PATH_VALUE' => $config['redblog_home_path'],

		'LANG_GENERAL_CONFIGS' => $lang['general_configs'],
		'LANG_RSS_CONFIGS' => $lang['rss_configs'],
		'LANG_FTP_CONFIGS' => $lang['ftp_configs'],
		'LANG_DRAWING_CONFIGS' => $lang['drawing_configs'],
		'LANG_TIME_DIFFERENCE' => $lang['time_difference'].' '.$current_time,
		'LANG_DATE_FORMAT' => $lang['date_format'],
		'DATE_FORMAT' => $config['date_format']
		)
	);
	
	
	// allow ftp
	$template->assign_vars(array(
		'LANG_YES' => $lang['yes'],
		'LANG_NO' => $lang['no'],
		'LANG_ALLOW_FTP' => $lang['allow_ftp'],
		'ALLOW_FTP_TRUE' => $config['allow_ftp'] ? 'checked="checked"' : '',
		'ALLOW_FTP_FALSE' => $config['allow_ftp'] ? '' : 'checked="checked"',
		'LANG_EXPLAIN_MAX_FILESIZE' => $lang['explain_max_filesize'],
		'MAX_FILESIZE_NOFTP' => ini_get('upload_max_filesize')
		)
	);
	
	//
	// Lang options
	//
	$template->assign_vars(array(
		'LANG_LANGUAGE' => $lang['language'])
	);
	// Now i scan lang directory for languages
	if ( !$handle = opendir($root_path."lang") ) {
		die ("Can't open languages directory!");
	}
	while (false !== ($file = readdir($handle))) {
		if ($file != "." && $file != "..") { 
			$language = str_replace ('.php', '', $file);
			$selected = '';
			if ( $language == $config['language'] ) {
				$selected = 'selected';
			}
			$template->assign_block_vars('lang_row', array(
				'SELECTED' => $selected,
				'LANGUAGE' => $language)
			);
		}
	}
	closedir($handle);
	
	//
	// Template options
	//
	$template->assign_vars(array(
		'LANG_TEMPLATE' => $lang['template'])
	);
	// Now i scan html dir for templates
	if ( !$handle = opendir($root_path."html") ) {
		die ("Can't open languages directory!");
	}
	while (false !== ($file = readdir($handle))) {
		if ($file != "." && $file != "..") {
			$selected = '';
			if ( $file == $config['template'] ) {
				$selected = 'selected';
			}
			$template->assign_block_vars('template_row', array(
				'SELECTED' => $selected,
				'NAME' => $file)
			);
		}
	}
	closedir($handle);
	
}

require_once($root_path . '/admin/page_header.php');

$template->pparse('body');

require_once($root_path . '/admin/page_footer.php');

?>
