<?php
/***************************************************************************
 *                            view_stats.php
 *                            -------------------
 *   copyright            : redgun
 *   email                : _redgun@libero.it
 *
 *   view_stats.php   start 25 September 2004
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
 
define('REDBLOG', true);
$root_path='./../';
require_once($root_path . 'common.php');
require_once($root_path . 'includes/functions.php');


// Only admin can access to this area
if (!admin_logged_in()) {
	header("Location:  http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php");
	exit;
}

$referers_per_page = 15; // for referer paginator


if ( isset($_GET['page']) ) {
	$page = $_GET['page'];
} else { $page = 0; }


if ( isset($_GET['stats']) && ($_GET['stats']=="on") ) {
	$expire = time() + 31536000*5; // five years
	setcookie('do_not_stat', 'true', $expire, '/');
	header("Location:  http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/view_stats.php");
	exit;
}
elseif ( isset($_GET['stats']) && ($_GET['stats']=="off")) {
	// delete cookie 
	// set expire time one hour ago
	setcookie('do_not_stat', '', time() - 3600, '/');
	header("Location:  http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/view_stats.php");
	exit;

}

if ( isset($_COOKIE['do_not_stat']) ) {
	$template->assign_vars(array(
		'LANG_STATUS' => $lang['stats_inactive'],
		'BUTTON_LABEL' => $lang['deactive_filter'],
		'ACTION' => "off")
	);
}
else {
	$template->assign_vars(array(
		'LANG_STATUS' => $lang['stats_active'],
		'BUTTON_LABEL' => $lang['active_filter'],
		'ACTION' => "on")
	);

}


// Get here a lot of stats
//
// Please remember that $stats object was initialized into common.php
//
$now = time() + ($config['time_difference'] * 3600);
$today = date("j", $now);
$current_month = date("n", $now);
$current_year = date("Y", $now);

$total_pages = $stats->total_pages();
$pages_today = $stats->pages_today();
$pages_current_month = $stats->pages_current_month();
$pages_previous_month = $stats->pages_previous_month();
$var=$stats->var_previous_month();
if ( $var === false ) {
	$var = $lang['cant_evalutate'];
}
// Stats from ...
$stats_from = $stats->stats_from();
$text_month = parse_months($current_month);
$display_date = $today." ".$text_month." ".$current_year." -- ".date("H:i",$now);

$template->assign_vars(array(
	'LANG_STATS_FROM' => $lang['stats_from'],
	'LANG_TOTAL_PAGES' => $lang['total_pages'],
	'LANG_PAGES_TODAY' => $lang['pages_today'],
	'LANG_PAGES_CURRENT_MONTH' => $lang['pages_current_month'],
	'TOTAL_PAGES' => $total_pages,
	'PAGES_TODAY' => $pages_today,
	'PAGES_CURRENT_MONTH' => $pages_current_month,
	'LANG_VAR' => $lang['var'],
	'VAR' => $var,
	'STATS_FROM' => $stats_from,
	'CURRENT_DATE' => $display_date
	)
);





// Paginator

$sql = "SELECT * FROM " . REFERERS_TABLE;
if( !($result = $db->sql_query($sql)) ) {
	die("Can't query referers table! ".$sql);
}
$referers_count = $db->sql_numrows();

$viewer_url = "view_stats.php?";
$paginator = paginator ($page, $referers_count, $referers_per_page, $viewer_url);
$template->assign_vars(array(
		'PAGINATOR' => $paginator)
	);

$start = $page * $referers_per_page; 



// query db for the stats
$sql = "SELECT * FROM " . REFERERS_TABLE . " ORDER BY referer_access_count DESC LIMIT ".$start.",".$referers_per_page;

if( !($result = $db->sql_query($sql)) ) {
	die("Can't query referers table!");
}

while ( $row = $db->sql_fetchrow($result) ) {
	$referer_url = $row['referer_desc'];
	
	// Make the link look clean
	$display_link = preg_replace("/http:\/\/([\w.-]+)\/(.*)/", "http://\\1/", $referer_url);
	
	$template->assign_block_vars('stats_row', array(
		'REFERER_LINK' => $referer_url,
		'DISPLAY_LINK' => $display_link,
		'ACCESS_COUNT' => $row['referer_access_count']
		)
	);
}


$users = $online_users->get_online_users(); // this object was created in commons.php

$template->assign_vars(array(
	'LANG_STATS' => $lang['stats'],
	'LANG_REFERER' => $lang['referer'],
	'LANG_ACCESS_COUNT' => $lang['access_count'],
	'LANG_ONLINE_USERS' => $lang['online_users'],
	'USERS_COUNT' => $users
	)
);



$template->set_filenames(array(
		'body' => 'admin/view_stats_body.html')
	);

require_once($root_path . '/admin/page_header.php');

$template->pparse('body');

require_once($root_path . '/admin/page_footer.php');

?>
