<?php
/***************************************************************************
 *                             functions.php
 *                            -------------------
 *   copyright            : redgun
 *   email                : _redgun@libero.it
 *   web		  : http://redblog.sf.net
 *
 *   functions.php   start 13 March 2004
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
 
function admin_logged_in(){
	global $config;
	if ( $_COOKIE['admin'] == $config['admin_password'] ) {
		return true;
	}
	return false;
}
 
function parse_smiles($msg) {
	global $db, $root_path;
	$sql = "SELECT * FROM " . SMILES_TABLE;
	if( !($result = $db->sql_query($sql)) ) {
		die("Impossibile ottenere le informazioni sugli smiles! ".$sql);
	}
	while ( $row = $db->sql_fetchrow($result) ) {
		$img_tag = "<img src=\"".$root_path."smiles/" . $row['smile_img'] . "\" alt=\"" . $row['smile_code']. "\" />";
		$msg = str_replace($row['smile_code'], $img_tag, $msg); 
	}
	return $msg;
}

function parse_bb_code ($message) {		
	
	 $preg = array(
	    // Font and text manipulation ( [color] [size] [font] [align] )
	    '/\[color=(.*?)(?::\w+)?\](.*?)\[\/color(?::\w+)?\]/si'   => "<span style=\"color:\\1\">\\2</span>",
	    '/\[size=(.*?)(?::\w+)?\](.*?)\[\/size(?::\w+)?\]/si'     => "<span style=\"font-size:\\1\">\\2</span>",
	    '/\[font=(.*?)(?::\w+)?\](.*?)\[\/font(?::\w+)?\]/si'     => "<span style=\"font-family:\\1\">\\2</span>",
	    '/\[align=(.*?)(?::\w+)?\](.*?)\[\/align(?::\w+)?\]/si'   => "<div style=\"text-align:\\1\">\\2</div>",
	    '/\[b(?::\w+)?\](.*?)\[\/b(?::\w+)?\]/si'                 => "<b>\\1</b>",
	    '/\[pre(?::\w+)?\](.*?)\[\/pre(?::\w+)?\]/si'	      => "<pre>\\1</pre>",
	    '/\[i(?::\w+)?\](.*?)\[\/i(?::\w+)?\]/si'                 => "<i>\\1</i>",
	    '/\[u(?::\w+)?\](.*?)\[\/u(?::\w+)?\]/si'                 => "<u>\\1</u>",
	    '/\[center(?::\w+)?\](.*?)\[\/center(?::\w+)?\]/si'       => "<div style=\"text-align:center\">\\1</div>",
	    // [email]
	    '/\[email(?::\w+)?\](.*?)\[\/email(?::\w+)?\]/si'         => "<a href=\"mailto:\\1\" class=\"ng_email\">\\1</a>",
	    '/\[email=(.*?)(?::\w+)?\](.*?)\[\/email(?::\w+)?\]/si'   => "<a href=\"mailto:\\1\" class=\"ng_email\">\\2</a>",
	    // [url]
	    '/\[url(?::\w+)?\]www\.(.*?)\[\/url(?::\w+)?\]/si'        => "<a href=\"http://www.\\1\"  class=\"ng_url\">\\1</a>",
	    '/\[url(?::\w+)?\](.*?)\[\/url(?::\w+)?\]/si'             => "<a href=\"\\1\"  class=\"ng_url\">\\1</a>",
	    '/\[url=(.*?)(?::\w+)?\](.*?)\[\/url(?::\w+)?\]/si'       => "<a href=\"\\1\"  class=\"ng_url\">\\2</a>",
	    // [img]
	    '/\[img(?::\w+)?\](.*?)\[\/img(?::\w+)?\]/si'             => "<img src=\"\\1\" border=\"0\" />",
	    '/\[img=(.*?)x(.*?)(?::\w+)?\](.*?)\[\/img(?::\w+)?\]/si' => "<img width=\"\\1\" height=\"\\2\" src=\"\\3\" border=\"0\" />",   
	    // [list]
	    '/\[\*(?::\w+)?\]\s*([^\[]*)/si'                          => "<li class=\"ng_list_item\">\\1</li>",
	    '/\[list(?::\w+)?\](.*?)\[\/list(?::\w+)?\]/si'           => "<ul class=\"ng_list\">\\1</ul>",
	    '/\[list(?::\w+)?\](.*?)\[\/list:u(?::\w+)?\]/s'          => "<ul class=\"ng_list\">\\1</ul>",
	    '/\[list=1(?::\w+)?\](.*?)\[\/list(?::\w+)?\]/si'         => "<ol class=\"ng_list\" style=\"list-style-type:decimal;\">\\1</ol>",
	    '/\[list=i(?::\w+)?\](.*?)\[\/list(?::\w+)?\]/s'          => "<ol class=\"ng_list\" style=\"list-style-type:lower-roman;\">\\1</ol>",
	    '/\[list=I(?::\w+)?\](.*?)\[\/list(?::\w+)?\]/s'          => "<ol class=\"ng_list\" style=\"list-style-type:upper-roman;\">\\1</ol>",
	    '/\[list=a(?::\w+)?\](.*?)\[\/list(?::\w+)?\]/s'          => "<ol class=\"ng_list\" style=\"list-style-type:lower-alpha;\">\\1</ol>",
	    '/\[list=A(?::\w+)?\](.*?)\[\/list(?::\w+)?\]/s'          => "<ol class=\"ng_list\" style=\"list-style-type:upper-alpha;\">\\1</ol>",
	    '/\[list(?::\w+)?\](.*?)\[\/list:o(?::\w+)?\]/s'          => "<ol class=\"ng_list\" style=\"list-style-type:decimal;\">\\1</ol>",
	    // the following lines clean up our output a bit
	    '/<ol(.*?)>(?:.*?)<li(.*?)>/si'         => "<ol\\1><li\\2>",
	    '/<ul(.*?)>(?:.*?)<li(.*?)>/si'         => "<ul\\1><li\\2>"
	  );
	  $message = preg_replace(array_keys($preg), array_values($preg), $message);

	// make clickable() :
	/**
	 * Rewritten by Nathan Codding - Feb 6, 2001.
	 * - Goes through the given string, and replaces xxxx://yyyy with an HTML <a> tag linking
	 * 	to that URL
	 * - Goes through the given string, and replaces www.xxxx.yyyy[zzzz] with an HTML <a> tag linking
	 * 	to http://www.xxxx.yyyy[/zzzz]
	 * - Goes through the given string, and replaces xxxx@yyyy with an HTML mailto: tag linking
	 *		to that email address
	 * - Only matches these 2 patterns either after a space, or at the beginning of a line
	 *
	 * Notes: the email one might get annoying - it's easy to make it more restrictive, though.. maybe
	 * have it require something like xxxx@yyyy.zzzz or such. We'll see.
	 */

	// pad it with a space so we can match things at the start of the 1st line.
	$ret = ' ' . $message;

	// matches an "xxxx://yyyy" URL at the start of a line, or after a space.
	// xxxx can only be alpha characters.
	// yyyy is anything up to the first space, newline, comma, double quote or <
	$ret = preg_replace("#([\t\r\n ])([a-z0-9]+?){1}://([\w\-]+\.([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^ \"\n\r\t<]*)?)#i", '\1<a href="\2://\3">\2://\3</a>', $ret);

	// matches a "www|ftp.xxxx.yyyy[/zzzz]" kinda lazy URL thing
	// Must contain at least 2 dots. xxxx contains either alphanum, or "-"
	// zzzz is optional.. will contain everything up to the first space, newline,
	// comma, double quote or <.
	$ret = preg_replace("#([\t\r\n ])(www|ftp)\.(([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^ \"\n\r\t<]*)?)#i", '\1<a href="http://\2.\3">\2.\3</a>', $ret);

	// matches an email@domain type address at the start of a line, or after a space.
	// Note: Only the followed chars are valid; alphanums, "-", "_" and or ".".
	$ret = preg_replace("#([\n ])([a-z0-9\-_.]+?)@([\w\-]+\.([\w\-\.]+\.)*[\w]+)#i", "\\1<a href=\"mailto:\\2@\\3\">\\2@\\3</a>", $ret);

	// Remove our padding..
	$ret = substr($ret, 1);

	return($ret);
}

function parse_all ($msg) {
	$msg = parse_smiles($msg);	
	$msg = parse_bb_code($msg);
	$msg = str_replace("\n", '<br/>', $msg);
	return $msg;
}

function parse_months( $month ){
	global $lang;
	switch ($month) {
		case 1   : return $lang['january'];    break;
		case 2   : return $lang['febrary'];    break;
		case 3   : return $lang['march'];      break;
		case 4   : return $lang['april'];      break;
		case 5   : return $lang['may'];        break;
		case 6   : return $lang['june'];       break;
		case 7   : return $lang['july'];       break;
		case 8   : return $lang['august'];     break;
		case 9   : return $lang['september'];  break;
		case 10  : return $lang['october'];    break;
		case 11  : return $lang['november'];   break;
		case 12  : return $lang['december'];   break;
	}
}


/**************************************************************
	This function create the page links

	It returns an empty string if page count = 0

	a fill string else


	Please remember that the client viewer must take a page var
	via the $_GET array

***************************************************************/

function paginator ( $current_page, $result_count, $result_per_page, $viewer_url) {
	global $lang;
	
	$paginator = '';
	$pages_count = ( ($result_count - 1) / $result_per_page ) +1;

	list($pages_count, $dec) = explode(".",$pages_count);

	if ($pages_count >= 1) {
		$paginator .='<span class="gen">'.$lang['page'].': ';
		if ( !($pages_count > 10) ) {
			$end = $pages_count;
			$begin = 0;
		}
		else {
			$prec = $current_page / 10;
			list($prec, $dec) =  explode(".",$prec);
			if ($current_page > 9) { // Remember that first page is the zero page
				$link =  ( ($prec - 1 ) *10 ) ;
				$paginator .= "<a href=\"".$viewer_url."&amp;page=".$link."\">&lt;&lt; </a>";
			}
			$begin = $prec * 10;
			if ($pages_count - ( ($begin+1) *10) > 0 ){	
				$end = $begin +10;
			}
			else $end = $pages_count;
		}
		for ( $i=$begin; $i < $end; $i++){
			if ($current_page != $i) {
				$paginator .= "<a href=\"".$viewer_url."&amp;page=".$i."\">".($i+1)." </a>";
			}
			else{
				$paginator .=($i+1). " ";
			}
		}
		if ( ($pages_count - $begin ) > 10) {
			$paginator .= "<a href=\"".$viewer_url."&amp;page=".$end."\">&gt;&gt; </a>";
		}	
		$paginator .="</span>";	
	}
	
	return $paginator;
}

?>
