<?php
/***************************************************************************
 *                            stats.php
 *                            -------------------
 *   copyright            : redgun
 *   email                : _redgun@libero.it
 *   web		  : http://redblog.sf.net
 *
 *    stats.php   start 25 September 2004
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if ( !defined('REDBLOG') ){
	die("Permission denied");
}


// This class will be initialized once in commons.php

class OnlineUsers {
	
	var $timeout = 600; // 10 minutes

	var $time;

	var $user_ip;
	
	// database object
	var $db;
	
	/*
		Constructor
	*/
	function OnlineUsers ( $db ){
		$this->db = $db;
		// get current timestamp
		$this->time = time();

		$this->user_ip = $this->get_ip();

		$this->add_user();

		$this->delete_old_users();
	}

	
	/*
		Private

		This function try to get the real user ip
	*/
	function get_ip() {
		if (getenv('HTTP_CLIENT_IP')) {
			$ip = getenv('HTTP_CLIENT_IP');
		}
		elseif (getenv('HTTP_X_FORWARDED_FOR')) {
			$ip = getenv('HTTP_X_FORWARDED_FOR');
		}
		elseif (getenv('HTTP_X_FORWARDED')) {
			$ip = getenv('HTTP_X_FORWARDED');
		}
		elseif (getenv('HTTP_FORWARDED_FOR')) {
			$ip = getenv('HTTP_FORWARDED_FOR');
		}
		elseif (getenv('HTTP_FORWARDED')) {
			$ip = getenv('HTTP_FORWARDED');
		}
		else {
			$ip = $_SERVER['REMOTE_ADDR'];
		}
		return $ip;
	}


	/*
		Private

		This function register user into database
	*/
	function add_user() {
		$sql = "INSERT INTO ".ONLINE_USERS_TABLE." VALUES('', '$this->user_ip', $this->time)";
		if( !($result = $this->db->sql_query($sql)) ) {
			die("Can't update online useres table! ");
		}
	}


	/*
		Private

		This function delete old users from db
	*/
	function delete_old_users() {
		$min_time = $this->time - $this->timeout;
		$sql = "DELETE FROM ".ONLINE_USERS_TABLE." WHERE time < ".$min_time;
		if( !($result = $this->db->sql_query($sql)) ) {
			die("Can't delete from online useres table! ");
		}

	}


	/*
		Public

		This function return current online users
	*/
	
	function get_online_users() {
		$sql = "SELECT DISTINCT(ip) FROM ".ONLINE_USERS_TABLE;
		if( !($result = $this->db->sql_query($sql)) ) {
			die("Can't query online useres table! ");
		}
		return $this->db->sql_numrows();
	}
}

?>
