<?php
/***************************************************************************
 *                            stats.php
 *                            -------------------
 *   copyright            : redgun
 *   email                : _redgun@libero.it
 *   web		  : http://redblog.sf.net
 *
 *    stats.php   start 25 September 2004
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if ( !defined('REDBLOG') ){
	die("Permission denied");
}


// This class will be initialized once in commons.php
// For now this class store referers into a db table

class Stats {

	// If a referer is oldest of current_time - max_referer_alive_time then it will be deleted
	// from db
	var $max_referer_alive_time = 2592000; // 30 days!!! [ 30 days * 24 hours * 60 minutes * 60 seconds ]


	// For page referer
	var $referer;

	// A db object
	var $db;


	var $time;

	var $today;
	var $current_month;
	var $current_year;
	var $previous_month;
	var $min_month;

	/* Constructor

	   Stats class need a db object to store data
	   db object must have a metod called sql_query (to query db) that work like this:

	   $result = $db->sql_query($query);

	   a sql_fetchrow (for fething result) metod callable like this:

	   $row = $db->sql_fetchrow($result);

	   and an sql_numrows for rows count
	 */
	function stats( $db, $time_difference ) {

		$this->db = $db;

		// get and store current time
		$this->time = time() + ($time_difference * 3600);

		$this->today = date("j", $this->time);
		$this->current_month = date("n", $this->time);
		$this->current_year = date("Y", $this->time);
		if ( $this->current_month == 1 ) {
			$this->previous_month = 12;
		}
		else {	
			$this->previous_month = $this->current_month - 1;
		}

		// Get referer string
		$this->referer = $_SERVER['HTTP_REFERER'];

		if ( empty($this->referer) ) {
			// Nothing to do
			return false;
		}

		if ( !($this->is_myself()) ) {
			if ( !( $this->is_already_stored () ) ){
				$this->store_referer ();
			}
		}
		$this->delete_old_referers();
		
		// If this is not the admin pc
		// Let's go to register current visit
		if ( !(isset($_COOKIE['do_not_stat'])) ) {
			$this->update_stats_table();
		}
	}


	/*
	   Private
	   
	   This function verify if the referer is myself
	 */
	function is_myself () {
		$ref = $this->referer;
		$my_server_name = $_SERVER['HTTP_HOST'];
		if ( strstr ( $ref, $my_server_name) ) {
			return true;
		}
		return false;
	}


	/*
	   Private

	   Check if referer is already stored into database
	   If yes update referer info
	 */
	function is_already_stored () {
		$ref = $this->referer;
		$sql = "SELECT * FROM " . REFERERS_TABLE . " WHERE referer_desc='" . $ref ."'";
		if( !($result = $this->db->sql_query($sql)) ) {
			die("Can't query referers table! ");
		}
		if ( $this->db->sql_numrows() > 0 ) {
			// Ok referer is already stored. Let's go update info
			$referer_info = $this->db->sql_fetchrow($result);
			$ac = $referer_info['referer_access_count'] + 1;
			$sql = "UPDATE " . REFERERS_TABLE. " 
				SET referer_time=" . $this->time . ", referer_access_count=" . $ac . " 
				WHERE referer_desc='" . $ref . "'";
			if( !($result = $this->db->sql_query($sql)) ) {
				die("Can't update referers table! ");
			}
			return true;
		}

		return false;
	}



	/*
	   Private

	   Store the referer into db
	 */
	function store_referer () {
		$ref = $this->referer;
		$time = $this->time;
		$sql = "INSERT INTO " . REFERERS_TABLE. " VALUES ('', '$ref', $time, 1)";
		if( !($result = $this->db->sql_query($sql)) ) {
			die("Can't update referers table! ");
		}
	}

	/*
	   Private

	   This function clean up the db for old referers.
	   A referer is old if it was stored before current_time - $max_referer_alive_time
	   and it was no more updated
	 */
	function delete_old_referers () {	
		$t = $this->time - $this->max_referer_alive_time;
		$sql = "DELETE FROM " . REFERERS_TABLE. " WHERE referer_time < ".$t;
		if( !($result = $this->db->sql_query($sql)) ) {
			die("Can't update referers table! ");
		}
	}


	/*
	   Private

	   This function search the stats table for a record with current
	   year, current month and current day. If it found him then update
	   the pages column (increment by 1) else it create the record and set
	   pages to zero

	 */

	function update_stats_table () {
		$year = date("Y", $this->time);
		$month = date("n", $this->time);
		$day = date("j", $this->time);

		$sql = "SELECT * FROM ".STATS_TABLE." 
			WHERE year=".$year." AND 
			month=".$month." AND 
			day=".$day;
		if( !($result = $this->db->sql_query($sql)) ) {
			die("Can't query stats table! ");
		}
		if ( $record = $this->db->sql_fetchrow($result) ) {
			$pages = $record['pages'];
			$pages++;
			$sql = "UPDATE ".STATS_TABLE." SET pages=".$pages." 
				WHERE year=".$year." AND 
				month=".$month." AND 
				day=".$day;
			if( !($result = $this->db->sql_query($sql)) ) {
				die("Can't update stats table! ");
			}
		}
		else {
			// Create a record for today
			$sql = "INSERT INTO ".STATS_TABLE." VALUES ($year, $month, $day, 0)";
			if( !($result = $this->db->sql_query($sql)) ) {
				die("Can't update stats table! ");
			}
		}
	}


	/*
		Public

		Return a formatted date from stat start
	   
	*/
	function stats_from () {
		
		$sql = "SELECT MIN(year) as min_year FROM ".STATS_TABLE;
		if( !($result = $this->db->sql_query($sql)) ) {
			die("Can't query referers table! ".$sql);
		}
		$r = $this->db->sql_fetchrow($result);
		$min_year = $r['min_year'];
		if ($min_year != "") {
			$sql = "SELECT MIN(month) as min_month FROM ".STATS_TABLE." WHERE year=".$min_year;
			if( !($result = $this->db->sql_query($sql)) ) {
				die("Can't query referers table! ".$sql);
			}
			$r = $this->db->sql_fetchrow($result);
			$min_month = $r['min_month'];
			if ( $min_month!="" ) {
				$sql = "SELECT MIN(day) as min_day FROM ".STATS_TABLE." WHERE year=".$min_year." AND month=".$min_month;
				if( !($result = $this->db->sql_query($sql)) ) {
					die("Can't query referers table! ".$sql);
				}
				$r = $this->db->sql_fetchrow($result);
				$min_day = $r['min_day'];
			}
		}
		
		$this->min_month = $min_month;
		
		return $min_day." ".parse_months($min_month)." ".$min_year;
	}

	/*
		Public

	*/
	function total_pages() {
		$sql = "SELECT SUM(pages) AS s FROM ".STATS_TABLE;
		if( !($result = $this->db->sql_query($sql)) ) {
			die("Can't query referers table! ".$sql);
		}
		$r = $this->db->sql_fetchrow($result);
		return $r['s'];
	}


	/*
		Public
	*/
	function pages_today() {
		$sql = "SELECT SUM(pages) AS s FROM ".STATS_TABLE." WHERE day=".$this->today." AND month=".$this->current_month." AND year=".$this->current_year;
		if( !($result = $this->db->sql_query($sql)) ) {
			die("Can't query referers table! ".$sql);
		}
		$r = $this->db->sql_fetchrow($result);
		$pages_today = $r['s'];
		if ( $pages_today =="") { $pages_today = 0;}

		return $pages_today;
	}

	/*
		Public		
	*/
	function pages_current_month() {
		$sql = "SELECT SUM(pages) AS s FROM ".STATS_TABLE." WHERE month=".$this->current_month." AND year=".$this->current_year;
		if( !($result = $this->db->sql_query($sql)) ) {
			die("Can't query referers table! ".$sql);
		}
		$r = $this->db->sql_fetchrow($result);
		$pages_current_month = $r['s'];
		if ( $pages_current_month =="") { $pages_current_month = 0;}
		
		return $pages_current_month;
	}

	/*
		Public
	*/
	function pages_previous_month() {
		$sql = "SELECT SUM(pages) AS s FROM ".STATS_TABLE." WHERE month=".$this->previous_month." AND year=".$this->current_year;
		if( !($result = $this->db->sql_query($sql)) ) {
			die("Can't query referers table! ".$sql);
		}
		$r = $this->db->sql_fetchrow($result);
		$pages_previous_month = $r['s'];
		if ( $pages_previous_month =="") { $pages_previous_month = 0;}
		
		return $pages_previous_month;
	}


	/*
		Public
	*/
	function var_previous_month() {
		// min month must be assigned from stats_from()
		if ( $this->min_month == 0 ){
			$this->stats_from();
		}		
		$pages_previous_month = $this->pages_previous_month();
		$pages_current_month = $this->pages_current_month();
		$sql = "SELECT MIN(day) AS md FROM ".STATS_TABLE." WHERE month=".$this->previous_month;
		if( !($result = $this->db->sql_query($sql)) ) {
			die("Can't query referers table! ".$sql);
		}
		$r = $this->db->sql_fetchrow($result);
		$min_day_previous_month = $r['md'] - 1;

		$days_previous_month = date("t", mktime(0, 0, 0, $this->previous_month, 1, $this->current_year) ) - $min_day_previous_month;

		if ($pages_previous_month != 0) {

			$average_previous_month = $pages_previous_month / $days_previous_month;
			$average_current_month = $pages_current_month / $this->today;
	
			$var = ( ($average_current_month - $average_previous_month) * 100 ) / $average_previous_month;
			if ($var > 0) {
				$var ="+".$var;
			}
			$var = preg_replace("/([+-]?)([0-9]*).([0-9]{2})([0-9]*)/","\\1\\2.\\3",$var)." %";
			return $var;
		}
		return false;
	}
		
}


?>
