<?php
/***************************************************************************
 *                            index.php
 *                            -------------------
 *   copyright            : redgun
 *   email                : _redgun@libero.it
 *   web		  : http://redblog.sourceforge.net
 *
 *    rss.php   start 12 August 2004
 *
 *              last  12 August 2004
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
 
define('REDBLOG', true);
$root_path='./';
require_once($root_path . 'common.php');
require_once($root_path . 'includes/functions.php');

$now = time ();
$month = date ("n", $now);
$year = date ("Y", $now);
$day = date ("j", $now);

$hours = 23;
$minutes = 59;
$seconds = 59;

if ( isset($_GET['month'])) {
	$month = $_GET['month'];
}
if ( isset($_GET['year'])) {
	$year = $_GET['year'];
}
if ( isset($_GET['day'])) {
	$day = $_GET['day'];
} else { $day = date("t",mktime(0, 0, 0, $month,1 ,$year));}

if ( isset($_GET['cat_id']) ) {
	$cat_id = $_GET['cat_id'];
}
else {
	$cat_id="";
}

// get some configs
$posts_per_page = $config['posts_per_page'];
$site_name = $config['site_name'];

// I'm in a specific page?
if ( isset($_GET['page'])) {
	$page = $_GET['page'];
} else { $page = 0; }

// start from
$start = $page * $posts_per_page;

$timestamp = mktime ($hours, $minutes, $seconds, $month, $day, $year);
$month_begin = mktime (0 , 0, 0, $month, 1, $year);
$sql = "SELECT * FROM ". POSTS_TABLE . " AS p, ". POSTS_CATEGORIES_TABLE ." AS pc 
		WHERE p.post_time < " . $timestamp . " 
			AND p.post_time > " . $month_begin . " 
			AND p.cat_id = pc.cat_id ";
if ($cat_id != '') {
	$sql .= "AND p.cat_id=".$cat_id." ";
}
$sql .="ORDER BY p.post_time DESC 
		LIMIT " . $start . ", " . $posts_per_page;

if( !($result = $db->sql_query($sql)) ) {
	die("Can't query posts table!<br/>".$sql);
}

// If in this month I don't have necessary posts to fill a page I consider previus months
if ($db->sql_numrows() < $posts_per_page) {
	$sql = "SELECT * FROM ". POSTS_TABLE . " AS p, ". POSTS_CATEGORIES_TABLE ." AS pc  
		WHERE post_time < " . $timestamp . " 
			AND p.cat_id = pc.cat_id ";
	if ($cat_id != '') {
		$sql .= "AND p.cat_id=".$cat_id." ";
	}
	$sql .= "ORDER BY post_time DESC 
		LIMIT " . $start . ", " . $posts_per_page;

	if( !($result = $db->sql_query($sql)) ) {
		die("Can't query posts table<br/>".$sql );
	}
}

$posts=array();
$i=0;
while ( $row = $db->sql_fetchrow($result) ) {
	$posts[$i]['post_id'] = $row['post_id'];
	$posts[$i]['post_title'] = $row['post_title'];
	$posts[$i]['post_text'] = $row['post_text'];
	$posts[$i]['post_time'] = $row['post_time'];
	$posts[$i]['post_modify_time'] = $row['post_modify_time'];
	$posts[$i]['post_comments'] = $row['post_comments'];
	$posts[$i]['cat_title'] = $row['cat_title'];
	$posts[$i]['cat_id'] = $row['cat_id'];
	
	$i++;
}

$template_link = "http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']);

//////////////////////////////
//
// Generate the xml
//

header("Content-Type: text/xml");
echo "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n\n";
echo "<rdf:RDF xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" xmlns=\"http://my.netscape.com/rdf/simple/0.9/\">";
echo "<channel>\n";
echo "<title>".htmlentities($site_name)."</title>\n";
echo "<link>".htmlentities($template_link)."</link>\n";
echo "<description></description>";
echo "</channel>";

//print count($posts);
for ($i=0; $i < count($posts); $i++) {
	$desc = parse_bb_code($posts[$i]['post_text']);
	$desc = str_replace("\n", '<br/>', $desc);
	$desc = htmlentities($desc);

		
	$date = date ('r', $posts[$i]['post_time']);
	
	// TODO: How much news are posted this day? More than $config['posts_per_page'] ?
	// If yes I must calculate in what page this post is
	//
	// NOTE: I must do this only if I decide to release all news I have ever posted in rss
	
	$news_link = $template_link."/index.php?month=".$month."&amp;day=".$day."&amp;year=".$year;
	
	echo "<item>\n";
	echo "  <title>".htmlentities($posts[$i]['post_title'])."</title>\n";
	echo "  <pubDate>".$date."</pubDate>";
	echo "  <description>".$desc."</description>\n";
	echo "  <link>".$news_link."</link>\n";
	echo "</item>\n";
}
echo "</rdf:RDF>";


// I not include page_footer.php here so I must close db manually
$db->sql_close();

?>
